diff --git a/src/backend/commands/tablecmds.c b/src/backend/commands/tablecmds.c
index eb2d33dd86..8a0fcd7ece 100644
--- a/src/backend/commands/tablecmds.c
+++ b/src/backend/commands/tablecmds.c
@@ -15084,13 +15300,14 @@ validatePartitionedIndex(Relation partedIdx, Relation partedTbl)
 }
 
 /*
- * Update the relispartition flag of the given relation to the given value.
+ * Update the relpartitionparent value of the given relation to the given
+ * value.
  *
  * classRel is the pg_class relation, already open and suitably locked.
  * It can be passed as NULL, in which case it's opened and closed locally.
  */
 static void
-update_relispartition(Relation classRel, Oid relationId, bool newval)
+update_relpartitionparent(Relation classRel, Oid relationId, Oid newparent)
 {
 	HeapTuple	tup;
 	HeapTuple	newtup;
@@ -15106,7 +15323,7 @@ update_relispartition(Relation classRel, Oid relationId, bool newval)
 	tup = SearchSysCache1(RELOID, ObjectIdGetDatum(relationId));
 	newtup = heap_copytuple(tup);
 	classForm = (Form_pg_class) GETSTRUCT(newtup);
-	classForm->relispartition = newval;
+	classForm->relpartitionparent = newparent;
 	CatalogTupleUpdate(classRel, &tup->t_self, newtup);
 	heap_freetuple(newtup);
 	ReleaseSysCache(tup);
diff --git a/src/backend/commands/trigger.c b/src/backend/commands/trigger.c
index 2436692eb8..8c712b97cc 100644
--- a/src/backend/commands/trigger.c
+++ b/src/backend/commands/trigger.c
@@ -363,8 +363,8 @@ CreateTrigger(CreateTrigStmt *stmt, const char *queryString,
 	partition_recurse = !isInternal && stmt->row &&
 		rel->rd_rel->relkind == RELKIND_PARTITIONED_TABLE;
 	if (partition_recurse)
-		list_free(find_all_inheritors(RelationGetRelid(rel),
-									  ShareRowExclusiveLock, NULL));
+		list_free(get_partition_descendants(RelationGetRelid(rel),
+											ShareRowExclusiveLock));
 
 	/* Compute tgtype */
 	TRIGGER_CLEAR_TYPE(tgtype);
@@ -453,14 +453,14 @@ CreateTrigger(CreateTrigStmt *stmt, const char *queryString,
 			 * tuples each child should see.  See also the prohibitions in
 			 * ATExecAttachPartition() and ATExecAddInherit().
 			 */
-			if (TRIGGER_FOR_ROW(tgtype) && has_superclass(rel->rd_id))
+			if (TRIGGER_FOR_ROW(tgtype))
 			{
 				/* Use appropriate error message. */
-				if (rel->rd_rel->relispartition)
+				if (OidIsValid(rel->rd_rel->relpartitionparent))
 					ereport(ERROR,
 							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
 							 errmsg("ROW triggers with transition tables are not supported on partitions")));
-				else
+				else if (has_superclass(rel->rd_id))
 					ereport(ERROR,
 							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
 							 errmsg("ROW triggers with transition tables are not supported on inheritance children")));
diff --git a/src/backend/commands/vacuum.c b/src/backend/commands/vacuum.c
index ee32fe8871..6ec8cee33f 100644
--- a/src/backend/commands/vacuum.c
+++ b/src/backend/commands/vacuum.c
@@ -31,6 +31,7 @@
 #include "access/transam.h"
 #include "access/xact.h"
 #include "catalog/namespace.h"
+#include "catalog/partition.h"
 #include "catalog/pg_database.h"
 #include "catalog/pg_inherits.h"
 #include "catalog/pg_namespace.h"
@@ -485,7 +486,7 @@ expand_vacuum_rel(VacuumRelation *vrel)
 		 */
 		if (include_parts)
 		{
-			List	   *part_oids = find_all_inheritors(relid, NoLock, NULL);
+			List	   *part_oids = get_partition_descendants(relid, NoLock);
 			ListCell   *part_lc;
 
 			foreach(part_lc, part_oids)
diff --git a/src/backend/executor/execPartition.c b/src/backend/executor/execPartition.c
index 7849e04bdb..448526d9f2 100644
--- a/src/backend/executor/execPartition.c
+++ b/src/backend/executor/execPartition.c
@@ -14,7 +14,6 @@
 #include "postgres.h"
 
 #include "catalog/partition.h"
-#include "catalog/pg_inherits.h"
 #include "catalog/pg_type.h"
 #include "executor/execPartition.h"
 #include "executor/executor.h"
@@ -80,7 +79,7 @@ ExecSetupPartitionTupleRouting(ModifyTableState *mtstate, Relation rel)
 	ModifyTable *node = mtstate ? (ModifyTable *) mtstate->ps.plan : NULL;
 
 	/* Lock all the partitions. */
-	(void) find_all_inheritors(RelationGetRelid(rel), RowExclusiveLock, NULL);
+	(void) get_partition_descendants(RelationGetRelid(rel), RowExclusiveLock);
 
 	/*
 	 * Here we attempt to expend as little effort as possible in setting up
diff --git a/src/backend/optimizer/prep/prepunion.c b/src/backend/optimizer/prep/prepunion.c
index 690b6bbab7..3896617760 100644
--- a/src/backend/optimizer/prep/prepunion.c
+++ b/src/backend/optimizer/prep/prepunion.c
@@ -99,9 +99,11 @@ static List *generate_append_tlist(List *colTypes, List *colCollations,
 					  List *input_tlists,
 					  List *refnames_tlist);
 static List *generate_setop_grouplist(SetOperationStmt *op, List *targetlist);
+static void expand_partitioned_rtentry(PlannerInfo *root, RangeTblEntry *rte,
+						   Index rti);
 static void expand_inherited_rtentry(PlannerInfo *root, RangeTblEntry *rte,
 						 Index rti);
-static void expand_partitioned_rtentry(PlannerInfo *root,
+static void expand_partitioned_rtentry_recurse(PlannerInfo *root,
 						   RangeTblEntry *parentrte,
 						   Index parentRTindex, Relation parentrel,
 						   PlanRowMark *top_parentrc, LOCKMODE lockmode,
@@ -1487,7 +1489,20 @@ expand_inherited_tables(PlannerInfo *root)
 	{
 		RangeTblEntry *rte = (RangeTblEntry *) lfirst(rl);
 
-		expand_inherited_rtentry(root, rte, rti);
+		if (rte->relkind == RELKIND_PARTITIONED_TABLE)
+			expand_partitioned_rtentry(root, rte, rti);
+		else if (OidIsValid(rte->relid))
+		{
+			/*
+			 * Partitioned tables cannot be part of an inheritance hierarchy,
+			 * so we needn't bother trying to expand those.
+			 */
+			if (OidIsValid(get_partition_parent(rte->relid)))
+				rte->inh = false;
+			else
+				expand_inherited_rtentry(root, rte, rti);
+		}
+		/* no need to attempt to expand anything else */
 		rl = lnext(rl);
 	}
 }
@@ -1522,6 +1537,11 @@ expand_inherited_rtentry(PlannerInfo *root, RangeTblEntry *rte, Index rti)
 	LOCKMODE	lockmode;
 	List	   *inhOIDs;
 	ListCell   *l;
+	List	   *appinfos = NIL;
+	RangeTblEntry *childrte;
+	Index		childRTindex;
+
+	Assert(rte->relkind != RELKIND_PARTITIONED_TABLE);
 
 	/* Does RT entry allow inheritance? */
 	if (!rte->inh)
@@ -1534,7 +1554,7 @@ expand_inherited_rtentry(PlannerInfo *root, RangeTblEntry *rte, Index rti)
 	}
 	/* Fast path for common case of childless table */
 	parentOID = rte->relid;
-	if (!has_subclass(parentOID))
+	if (rte->relkind != RELKIND_PARTITIONED_TABLE && !has_subclass(parentOID))
 	{
 		/* Clear flag before returning */
 		rte->inh = false;
@@ -1591,93 +1611,137 @@ expand_inherited_rtentry(PlannerInfo *root, RangeTblEntry *rte, Index rti)
 	 */
 	oldrelation = heap_open(parentOID, NoLock);
 
-	/* Scan the inheritance set and expand it */
-	if (RelationGetPartitionDesc(oldrelation) != NULL)
+	Assert(!RelationGetPartitionDesc(oldrelation));
+
+	/*
+		* This table has no partitions.  Expand any plain inheritance
+		* children in the order the OIDs were returned by
+		* find_all_inheritors.
+		*/
+	foreach(l, inhOIDs)
 	{
-		Assert(rte->relkind == RELKIND_PARTITIONED_TABLE);
+		Oid			childOID = lfirst_oid(l);
+		Relation	newrelation;
+
+		/* Open rel if needed; we already have required locks */
+		if (childOID != parentOID)
+			newrelation = heap_open(childOID, NoLock);
+		else
+			newrelation = oldrelation;
 
 		/*
-		 * If this table has partitions, recursively expand them in the order
-		 * in which they appear in the PartitionDesc.  While at it, also
-		 * extract the partition key columns of all the partitioned tables.
-		 */
-		expand_partitioned_rtentry(root, rte, rti, oldrelation, oldrc,
-								   lockmode, &root->append_rel_list);
+			* It is possible that the parent table has children that are temp
+			* tables of other backends.  We cannot safely access such tables
+			* (because of buffering issues), and the best thing to do seems
+			* to be to silently ignore them.
+			*/
+		if (childOID != parentOID && RELATION_IS_OTHER_TEMP(newrelation))
+		{
+			heap_close(newrelation, lockmode);
+			continue;
+		}
+
+		expand_single_inheritance_child(root, rte, rti, oldrelation, oldrc,
+										newrelation,
+										&appinfos, &childrte,
+										&childRTindex);
+
+		/* Close child relations, but keep locks */
+		if (childOID != parentOID)
+			heap_close(newrelation, NoLock);
 	}
+
+	/*
+		* If all the children were temp tables, pretend it's a
+		* non-inheritance situation; we don't need Append node in that case.
+		* The duplicate RTE we added for the parent table is harmless, so we
+		* don't bother to get rid of it; ditto for the useless PlanRowMark
+		* node.
+		*/
+	if (list_length(appinfos) < 2)
+		rte->inh = false;
 	else
-	{
-		List	   *appinfos = NIL;
-		RangeTblEntry *childrte;
-		Index		childRTindex;
+		root->append_rel_list = list_concat(root->append_rel_list,
+											appinfos);
 
-		/*
-		 * This table has no partitions.  Expand any plain inheritance
-		 * children in the order the OIDs were returned by
-		 * find_all_inheritors.
-		 */
-		foreach(l, inhOIDs)
-		{
-			Oid			childOID = lfirst_oid(l);
-			Relation	newrelation;
+	heap_close(oldrelation, NoLock);
+}
 
-			/* Open rel if needed; we already have required locks */
-			if (childOID != parentOID)
-				newrelation = heap_open(childOID, NoLock);
-			else
-				newrelation = oldrelation;
+static void
+expand_partitioned_rtentry(PlannerInfo *root, RangeTblEntry *rte, Index rti)
+{
+	Query	   *parse = root->parse;
+	PlanRowMark *partrc;
+	Relation	partrel;
+	LOCKMODE	lockmode;
+	PartitionDesc partdesc;
 
-			/*
-			 * It is possible that the parent table has children that are temp
-			 * tables of other backends.  We cannot safely access such tables
-			 * (because of buffering issues), and the best thing to do seems
-			 * to be to silently ignore them.
-			 */
-			if (childOID != parentOID && RELATION_IS_OTHER_TEMP(newrelation))
-			{
-				heap_close(newrelation, lockmode);
-				continue;
-			}
+	Assert(rte->relkind == RELKIND_PARTITIONED_TABLE);
+
+	/* Support legacy ONLY syntax for partitions */
+	if (!rte->inh)
+		return;
 
-			expand_single_inheritance_child(root, rte, rti, oldrelation, oldrc,
-											newrelation,
-											&appinfos, &childrte,
-											&childRTindex);
+	/*
+	 * The rewriter should already have obtained an appropriate lock on each
+	 * relation named in the query.  However, for each child relation we add
+	 * to the query, we must obtain an appropriate lock, because this will be
+	 * the first use of those relations in the parse/rewrite/plan pipeline.
+	 *
+	 * If the parent relation is the query's result relation, then we need
+	 * RowExclusiveLock.  Otherwise, if it's accessed FOR UPDATE/SHARE, we
+	 * need RowShareLock; otherwise AccessShareLock.  We can't just grab
+	 * AccessShareLock because then the executor would be trying to upgrade
+	 * the lock, leading to possible deadlocks.  (This code should match the
+	 * parser and rewriter.)
+	 */
+	partrc = get_plan_rowmark(root->rowMarks, rti);
+	if (rti == parse->resultRelation)
+		lockmode = RowExclusiveLock;
+	else if (partrc && RowMarkRequiresRowShareLock(partrc->markType))
+		lockmode = RowShareLock;
+	else
+		lockmode = AccessShareLock;
 
-			/* Close child relations, but keep locks */
-			if (childOID != parentOID)
-				heap_close(newrelation, NoLock);
-		}
+	/*
+	 * If parent relation is selected FOR UPDATE/SHARE, we need to mark its
+	 * PlanRowMark as isParent = true, and generate a new PlanRowMark for each
+	 * child.
+	 */
+	if (partrc)
+		partrc->isParent = true;
 
-		/*
-		 * If all the children were temp tables, pretend it's a
-		 * non-inheritance situation; we don't need Append node in that case.
-		 * The duplicate RTE we added for the parent table is harmless, so we
-		 * don't bother to get rid of it; ditto for the useless PlanRowMark
-		 * node.
-		 */
-		if (list_length(appinfos) < 2)
-			rte->inh = false;
-		else
-			root->append_rel_list = list_concat(root->append_rel_list,
-												appinfos);
+	/*
+	 * Must open the partitioned relation to examine its tupdesc.  We need not
+	 * lock it; we assume the rewriter already did.
+	 */
+	partrel = heap_open(rte->relid, NoLock);
 
-	}
+	partdesc = RelationGetPartitionDesc(partrel);
 
-	heap_close(oldrelation, NoLock);
+	/*
+	 * If this table has partitions, recursively expand them in the order in
+	 * which they appear in the PartitionDesc.  While at it, also extract the
+	 * partition key columns of all the partitioned tables.
+	 */
+	expand_partitioned_rtentry_recurse(root, rte, rti, partrel, partrc,
+									   lockmode, &root->append_rel_list);
+
+	heap_close(partrel, NoLock);
 }
 
 /*
- * expand_partitioned_rtentry
+ * expand_partitioned_rtentry_recurse
  *		Recursively expand an RTE for a partitioned table.
  *
  * Note that RelationGetPartitionDispatchInfo will expand partitions in the
  * same order as this code.
  */
 static void
-expand_partitioned_rtentry(PlannerInfo *root, RangeTblEntry *parentrte,
-						   Index parentRTindex, Relation parentrel,
-						   PlanRowMark *top_parentrc, LOCKMODE lockmode,
-						   List **appinfos)
+expand_partitioned_rtentry_recurse(PlannerInfo *root, RangeTblEntry *parentrte,
+								   Index parentRTindex, Relation parentrel,
+								   PlanRowMark *top_parentrc, LOCKMODE lockmode,
+								   List **appinfos)
 {
 	int			i;
 	RangeTblEntry *childrte;
@@ -1689,8 +1753,6 @@ expand_partitioned_rtentry(PlannerInfo *root, RangeTblEntry *parentrte,
 	/* A partitioned table should always have a partition descriptor. */
 	Assert(partdesc);
 
-	Assert(parentrte->inh);
-
 	/*
 	 * Note down whether any partition key cols are being updated. Though it's
 	 * the root partitioned table's updatedCols we are interested in, we
@@ -1722,16 +1784,7 @@ expand_partitioned_rtentry(PlannerInfo *root, RangeTblEntry *parentrte,
 		Oid			childOID = partdesc->oids[i];
 		Relation	childrel;
 
-		/* Open rel; we already have required locks */
-		childrel = heap_open(childOID, NoLock);
-
-		/*
-		 * Temporary partitions belonging to other sessions should have been
-		 * disallowed at definition, but for paranoia's sake, let's double
-		 * check.
-		 */
-		if (RELATION_IS_OTHER_TEMP(childrel))
-			elog(ERROR, "temporary relation from another session found as partition");
+		childrel = heap_open(childOID, lockmode);
 
 		expand_single_inheritance_child(root, parentrte, parentRTindex,
 										parentrel, top_parentrc, childrel,
@@ -1739,7 +1792,7 @@ expand_partitioned_rtentry(PlannerInfo *root, RangeTblEntry *parentrte,
 
 		/* If this child is itself partitioned, recurse */
 		if (childrel->rd_rel->relkind == RELKIND_PARTITIONED_TABLE)
-			expand_partitioned_rtentry(root, childrte, childRTindex,
+			expand_partitioned_rtentry_recurse(root, childrte, childRTindex,
 									   childrel, top_parentrc, lockmode,
 									   appinfos);
 
diff --git a/src/backend/partitioning/partbounds.c b/src/backend/partitioning/partbounds.c
index 9015a05d32..360d4e08cd 100644
--- a/src/backend/partitioning/partbounds.c
+++ b/src/backend/partitioning/partbounds.c
@@ -15,6 +15,7 @@
 
 #include "catalog/partition.h"
 #include "catalog/pg_inherits.h"
+#include "catalog/pg_partition.h"
 #include "catalog/pg_type.h"
 #include "commands/tablecmds.h"
 #include "executor/executor.h"
@@ -628,8 +629,8 @@ check_default_partition_contents(Relation parent, Relation default_rel,
 	 * that do not satisfy the revised partition constraints.
 	 */
 	if (default_rel->rd_rel->relkind == RELKIND_PARTITIONED_TABLE)
-		all_parts = find_all_inheritors(RelationGetRelid(default_rel),
-										AccessExclusiveLock, NULL);
+		all_parts = get_partition_descendants(RelationGetRelid(default_rel),
+											  AccessExclusiveLock);
 	else
 		all_parts = list_make1_oid(RelationGetRelid(default_rel));
 
@@ -1634,12 +1635,12 @@ get_qual_for_range(Relation parent, PartitionBoundSpec *spec,
 			bool		isnull;
 			PartitionBoundSpec *bspec;
 
-			tuple = SearchSysCache1(RELOID, inhrelid);
+			tuple = SearchSysCache1(PARTSRELID, inhrelid);
 			if (!HeapTupleIsValid(tuple))
 				elog(ERROR, "cache lookup failed for relation %u", inhrelid);
 
-			datum = SysCacheGetAttr(RELOID, tuple,
-									Anum_pg_class_relpartbound,
+			datum = SysCacheGetAttr(PARTSRELID, tuple,
+									Anum_pg_partition_partbound,
 									&isnull);
 
 			Assert(!isnull);
diff --git a/src/backend/rewrite/rewriteDefine.c b/src/backend/rewrite/rewriteDefine.c
index d81a2ea342..3c5e8e75d6 100644
--- a/src/backend/rewrite/rewriteDefine.c
+++ b/src/backend/rewrite/rewriteDefine.c
@@ -428,7 +428,7 @@ DefineQueryRewrite(const char *rulename,
 						 errmsg("cannot convert partitioned table \"%s\" to a view",
 								RelationGetRelationName(event_relation))));
 
-			if (event_relation->rd_rel->relispartition)
+			if (OidIsValid(event_relation->rd_rel->relpartitionparent))
 				ereport(ERROR,
 						(errcode(ERRCODE_WRONG_OBJECT_TYPE),
 						 errmsg("cannot convert partition \"%s\" to a view",
diff --git a/src/backend/tcop/utility.c b/src/backend/tcop/utility.c
index b5804f64ad..51e0e789f3 100644
--- a/src/backend/tcop/utility.c
+++ b/src/backend/tcop/utility.c
@@ -25,6 +25,7 @@
 #include "catalog/namespace.h"
 #include "catalog/pg_inherits.h"
 #include "catalog/toasting.h"
+#include "catalog/partition.h"
 #include "commands/alter.h"
 #include "commands/async.h"
 #include "commands/cluster.h"
@@ -1323,10 +1324,10 @@ ProcessUtilitySlow(ParseState *pstate,
 						get_rel_relkind(relid) == RELKIND_PARTITIONED_TABLE)
 					{
 						ListCell   *lc;
-						List	   *inheritors = NIL;
+						List	   *partoids = NIL;
 
-						inheritors = find_all_inheritors(relid, lockmode, NULL);
-						foreach(lc, inheritors)
+						partoids = get_partition_descendants(relid, lockmode);
+						foreach(lc, partoids)
 						{
 							char		relkind = get_rel_relkind(lfirst_oid(lc));
 
@@ -1340,7 +1341,7 @@ ProcessUtilitySlow(ParseState *pstate,
 										 errdetail("Table \"%s\" contains partitions that are foreign tables.",
 												   stmt->relation->relname)));
 						}
-						list_free(inheritors);
+						list_free(partoids);
 					}
 
 					/* Run parse analysis ... */
diff --git a/src/backend/utils/cache/partcache.c b/src/backend/utils/cache/partcache.c
index 82acfeb460..51a21c4793 100644
--- a/src/backend/utils/cache/partcache.c
+++ b/src/backend/utils/cache/partcache.c
@@ -18,9 +18,10 @@
 #include "access/heapam.h"
 #include "access/htup_details.h"
 #include "access/nbtree.h"
+#include "catalog/indexing.h"
 #include "catalog/partition.h"
-#include "catalog/pg_inherits.h"
 #include "catalog/pg_opclass.h"
+#include "catalog/pg_partition.h"
 #include "catalog/pg_partitioned_table.h"
 #include "miscadmin.h"
 #include "nodes/makefuncs.h"
@@ -30,6 +31,7 @@
 #include "partitioning/partbounds.h"
 #include "utils/builtins.h"
 #include "utils/datum.h"
+#include "utils/fmgroids.h"
 #include "utils/lsyscache.h"
 #include "utils/memutils.h"
 #include "utils/partcache.h"
@@ -260,8 +262,7 @@ RelationBuildPartitionKey(Relation relation)
 void
 RelationBuildPartitionDesc(Relation rel)
 {
-	List	   *inhoids,
-			   *partoids;
+	List	   *partoids;
 	Oid		   *oids = NULL;
 	List	   *boundspecs = NIL;
 	ListCell   *cell;
@@ -270,6 +271,10 @@ RelationBuildPartitionDesc(Relation rel)
 	PartitionKey key = RelationGetPartitionKey(rel);
 	PartitionDesc result;
 	MemoryContext oldcxt;
+	SysScanDesc scan;
+	ScanKeyData scankey[1];
+	Relation	pgpart;
+	HeapTuple	partTuple;
 
 	int			ndatums = 0;
 	int			default_index = -1;
@@ -285,39 +290,47 @@ RelationBuildPartitionDesc(Relation rel)
 	PartitionRangeBound **rbounds = NULL;
 
 	/* Get partition oids from pg_inherits */
-	inhoids = find_inheritance_children(RelationGetRelid(rel), NoLock);
+	pgpart = heap_open(PartitionRelationId, AccessShareLock);
+
+	ScanKeyInit(&scankey[0],
+				Anum_pg_partition_parentrelid,
+				BTEqualStrategyNumber, F_OIDEQ,
+				ObjectIdGetDatum(RelationGetRelid(rel)));
+
+	scan = systable_beginscan(pgpart, PartitionParentrelidIndexId, true,
+							  NULL, 1, scankey);
 
 	/* Collect bound spec nodes in a list */
-	i = 0;
 	partoids = NIL;
-	foreach(cell, inhoids)
+	while ((partTuple = systable_getnext(scan)) != NULL)
 	{
-		Oid			inhrelid = lfirst_oid(cell);
+		Oid			partrelid = ((Form_pg_partition) GETSTRUCT(partTuple))->partrelid;
 		HeapTuple	tuple;
 		Datum		datum;
 		bool		isnull;
 		Node	   *boundspec;
 
-		tuple = SearchSysCache1(RELOID, inhrelid);
+		tuple = SearchSysCache1(RELOID, partrelid);
 		if (!HeapTupleIsValid(tuple))
-			elog(ERROR, "cache lookup failed for relation %u", inhrelid);
+			elog(ERROR, "cache lookup failed for relation %u", partrelid);
 
 		/*
 		 * It is possible that the pg_class tuple of a partition has not been
 		 * updated yet to set its relpartbound field.  The only case where
 		 * this happens is when we open the parent relation to check using its
 		 * partition descriptor that a new partition's bound does not overlap
-		 * some existing partition.
+		 * some existing partition. XXX needs updated! Figure out if this is
+		 * still required.
 		 */
-		if (!((Form_pg_class) GETSTRUCT(tuple))->relispartition)
+		if (!OidIsValid(((Form_pg_class) GETSTRUCT(tuple))->relpartitionparent))
 		{
 			ReleaseSysCache(tuple);
 			continue;
 		}
 
-		datum = SysCacheGetAttr(RELOID, tuple,
-								Anum_pg_class_relpartbound,
-								&isnull);
+		datum = fastgetattr(partTuple, Anum_pg_partition_partbound,
+							pgpart->rd_att, &isnull);
+
 		Assert(!isnull);
 		boundspec = (Node *) stringToNode(TextDatumGetCString(datum));
 
@@ -331,16 +344,20 @@ RelationBuildPartitionDesc(Relation rel)
 			Oid			partdefid;
 
 			partdefid = get_default_partition_oid(RelationGetRelid(rel));
-			if (partdefid != inhrelid)
+			if (partdefid != partrelid)
 				elog(ERROR, "expected partdefid %u, but got %u",
-					 inhrelid, partdefid);
+					 partrelid, partdefid);
 		}
 
 		boundspecs = lappend(boundspecs, boundspec);
-		partoids = lappend_oid(partoids, inhrelid);
+		partoids = lappend_oid(partoids, partrelid);
 		ReleaseSysCache(tuple);
 	}
 
+	systable_endscan(scan);
+
+	heap_close(pgpart, AccessShareLock);
+
 	nparts = list_length(partoids);
 
 	if (nparts > 0)
@@ -808,7 +825,7 @@ List *
 RelationGetPartitionQual(Relation rel)
 {
 	/* Quick exit */
-	if (!rel->rd_rel->relispartition)
+	if (!OidIsValid(rel->rd_rel->relpartitionparent))
 		return NIL;
 
 	return generate_partition_qual(rel);
@@ -829,7 +846,7 @@ get_partition_qual_relid(Oid relid)
 	List	   *and_args;
 
 	/* Do the work only if this relation is a partition. */
-	if (rel->rd_rel->relispartition)
+	if (OidIsValid(rel->rd_rel->relpartitionparent))
 	{
 		and_args = generate_partition_qual(rel);
 
@@ -880,20 +897,19 @@ generate_partition_qual(Relation rel)
 		return copyObject(rel->rd_partcheck);
 
 	/* Grab at least an AccessShareLock on the parent table */
-	parent = heap_open(get_partition_parent(RelationGetRelid(rel)),
-					   AccessShareLock);
+	parent = heap_open(RelationGetParentRelid(rel), AccessShareLock);
 
-	/* Get pg_class.relpartbound */
-	tuple = SearchSysCache1(RELOID, RelationGetRelid(rel));
+	/* Get pg_partition.partbound */
+	tuple = SearchSysCache1(PARTSRELID, RelationGetRelid(rel));
 	if (!HeapTupleIsValid(tuple))
 		elog(ERROR, "cache lookup failed for relation %u",
 			 RelationGetRelid(rel));
 
-	boundDatum = SysCacheGetAttr(RELOID, tuple,
-								 Anum_pg_class_relpartbound,
+	boundDatum = SysCacheGetAttr(PARTSRELID, tuple,
+								 Anum_pg_partition_partbound,
 								 &isnull);
 	if (isnull)					/* should not happen */
-		elog(ERROR, "relation \"%s\" has relpartbound = null",
+		elog(ERROR, "relation \"%s\" has partbound = null",
 			 RelationGetRelationName(rel));
 	bound = castNode(PartitionBoundSpec,
 					 stringToNode(TextDatumGetCString(boundDatum)));
@@ -902,7 +918,7 @@ generate_partition_qual(Relation rel)
 	my_qual = get_qual_from_partbound(rel, parent, bound);
 
 	/* Add the parent's quals to the list (if any) */
-	if (parent->rd_rel->relispartition)
+	if (OidIsValid(parent->rd_rel->relpartitionparent))
 		result = list_concat(generate_partition_qual(parent), my_qual);
 	else
 		result = my_qual;
diff --git a/src/backend/utils/cache/syscache.c b/src/backend/utils/cache/syscache.c
index 2b381782a3..8ad9d2fa3b 100644
--- a/src/backend/utils/cache/syscache.c
+++ b/src/backend/utils/cache/syscache.c
@@ -48,6 +48,7 @@
 #include "catalog/pg_opclass.h"
 #include "catalog/pg_operator.h"
 #include "catalog/pg_opfamily.h"
+#include "catalog/pg_partition.h"
 #include "catalog/pg_partitioned_table.h"
 #include "catalog/pg_proc.h"
 #include "catalog/pg_publication.h"
@@ -584,6 +585,17 @@ static const struct cachedesc cacheinfo[] = {
 		},
 		32
 	},
+	{PartitionRelationId,		/* PARTSRELID */
+		PartitionRelidIndexId,
+		1,
+		{
+			Anum_pg_partition_partrelid,
+			0,
+			0,
+			0
+		},
+		32
+	},
 	{ProcedureRelationId,		/* PROCNAMEARGSNSP */
 		ProcedureNameArgsNspIndexId,
 		3,
@@ -1238,7 +1250,7 @@ GetSysCacheOid(int cacheId,
 
 /*
  * SearchSysCacheAttName
- *
+ *subqu
  * This routine is equivalent to SearchSysCache on the ATTNAME cache,
  * except that it will return NULL if the found attribute is marked
  * attisdropped.  This is convenient for callers that want to act as
diff --git a/src/bin/pg_dump/common.c b/src/bin/pg_dump/common.c
index 0d147cb08d..4f6c68e844 100644
--- a/src/bin/pg_dump/common.c
+++ b/src/bin/pg_dump/common.c
@@ -1022,6 +1022,28 @@ findParentsByOid(TableInfo *self,
 				j;
 	int			numParents;
 
+	/*
+	 * For PG12 and above pg_class has a relpartitionparent column that allows
+	 * us to determine the parent without looking at the inheritance data.
+	 */
+	if (self->partitionparent != 0)
+	{
+		self->parents = (TableInfo **) pg_malloc(sizeof(TableInfo *));
+
+		self->parents[0] = findTableByOid(self->partitionparent);
+
+		if (self->parents[0] == NULL)
+		{
+			write_msg(NULL, "failed sanity check, parent OID %u of table \"%s\" (OID %u) not found\n",
+						self->partitionparent,
+						self->dobj.name,
+						oid);
+			exit_nicely(1);
+		}
+		self->numParents = 1;
+		return;
+	}
+
 	numParents = 0;
 	for (i = 0; i < numInherits; i++)
 	{
diff --git a/src/bin/pg_dump/pg_dump.c b/src/bin/pg_dump/pg_dump.c
index 20e8aedb19..af7e2bd813 100644
--- a/src/bin/pg_dump/pg_dump.c
+++ b/src/bin/pg_dump/pg_dump.c
@@ -5878,6 +5878,7 @@ getTables(Archive *fout, int *numTables)
 	int			i_changed_acl;
 	int			i_partkeydef;
 	int			i_ispartition;
+	int			i_partitionparent;
 	int			i_partbound;
 
 	/*
@@ -5904,7 +5905,9 @@ getTables(Archive *fout, int *numTables)
 	{
 		char	   *partkeydef = "NULL";
 		char	   *ispartition = "false";
+		char	   *partitionparent = "0";
 		char	   *partbound = "NULL";
+		char	   *partjoin = "";
 
 		PQExpBuffer acl_subquery = createPQExpBuffer();
 		PQExpBuffer racl_subquery = createPQExpBuffer();
@@ -5920,14 +5923,23 @@ getTables(Archive *fout, int *numTables)
 		 * Collect the information about any partitioned tables, which were
 		 * added in PG10.
 		 */
-
-		if (fout->remoteVersion >= 100000)
+		/* XXX how much do we add here before we split this out completely? */
+		if (fout->remoteVersion >= 120000)
+		{
+			partjoin = "LEFT JOIN pg_partition p ON (c.oid = p.partrelid) ";
+			partkeydef = "pg_get_partkeydef(c.oid)";
+			ispartition = "c.relpartitionparent <> 0";
+			partitionparent = "c.relpartitionparent";
+			partbound = "pg_get_expr(p.partbound, c.oid)";
+		}
+		else if (fout->remoteVersion >= 100000)
 		{
 			partkeydef = "pg_get_partkeydef(c.oid)";
 			ispartition = "c.relispartition";
 			partbound = "pg_get_expr(c.relpartbound, c.oid)";
 		}
 
+
 		/*
 		 * Left join to pick up dependency info linking sequences to their
 		 * owning column, if any (note this dependency is AUTO as of 8.2)
@@ -5982,6 +5994,7 @@ getTables(Archive *fout, int *numTables)
 						  "AS changed_acl, "
 						  "%s AS partkeydef, "
 						  "%s AS ispartition, "
+						  "%s AS partitionparent, "
 						  "%s AS partbound "
 						  "FROM pg_class c "
 						  "LEFT JOIN pg_depend d ON "
@@ -5994,6 +6007,7 @@ getTables(Archive *fout, int *numTables)
 						  "(c.oid = pip.objoid "
 						  "AND pip.classoid = 'pg_class'::regclass "
 						  "AND pip.objsubid = 0) "
+						  "%s"
 						  "WHERE c.relkind in ('%c', '%c', '%c', '%c', '%c', '%c', '%c') "
 						  "ORDER BY c.oid",
 						  acl_subquery->data,
@@ -6008,8 +6022,10 @@ getTables(Archive *fout, int *numTables)
 						  attinitracl_subquery->data,
 						  partkeydef,
 						  ispartition,
+						  partitionparent,
 						  partbound,
 						  RELKIND_SEQUENCE,
+						  partjoin,
 						  RELKIND_RELATION, RELKIND_SEQUENCE,
 						  RELKIND_VIEW, RELKIND_COMPOSITE_TYPE,
 						  RELKIND_MATVIEW, RELKIND_FOREIGN_TABLE,
@@ -6057,6 +6073,7 @@ getTables(Archive *fout, int *numTables)
 						  "NULL AS changed_acl, "
 						  "NULL AS partkeydef, "
 						  "false AS ispartition, "
+						  "0 AS partitionparent, "
 						  "NULL AS partbound "
 						  "FROM pg_class c "
 						  "LEFT JOIN pg_depend d ON "
@@ -6106,6 +6123,7 @@ getTables(Archive *fout, int *numTables)
 						  "NULL AS changed_acl, "
 						  "NULL AS partkeydef, "
 						  "false AS ispartition, "
+						  "0 AS partitionparent, "
 						  "NULL AS partbound "
 						  "FROM pg_class c "
 						  "LEFT JOIN pg_depend d ON "
@@ -6155,6 +6173,7 @@ getTables(Archive *fout, int *numTables)
 						  "NULL AS changed_acl, "
 						  "NULL AS partkeydef, "
 						  "false AS ispartition, "
+						  "0 AS partitionparent, "
 						  "NULL AS partbound "
 						  "FROM pg_class c "
 						  "LEFT JOIN pg_depend d ON "
@@ -6202,6 +6221,7 @@ getTables(Archive *fout, int *numTables)
 						  "NULL AS changed_acl, "
 						  "NULL AS partkeydef, "
 						  "false AS ispartition, "
+						  "0 AS partitionparent, "
 						  "NULL AS partbound "
 						  "FROM pg_class c "
 						  "LEFT JOIN pg_depend d ON "
@@ -6249,6 +6269,7 @@ getTables(Archive *fout, int *numTables)
 						  "NULL AS changed_acl, "
 						  "NULL AS partkeydef, "
 						  "false AS ispartition, "
+						  "0 AS partitionparent, "
 						  "NULL AS partbound "
 						  "FROM pg_class c "
 						  "LEFT JOIN pg_depend d ON "
@@ -6295,6 +6316,7 @@ getTables(Archive *fout, int *numTables)
 						  "NULL AS changed_acl, "
 						  "NULL AS partkeydef, "
 						  "false AS ispartition, "
+						  "0 AS partitionparent, "
 						  "NULL AS partbound "
 						  "FROM pg_class c "
 						  "LEFT JOIN pg_depend d ON "
@@ -6341,6 +6363,7 @@ getTables(Archive *fout, int *numTables)
 						  "NULL AS changed_acl, "
 						  "NULL AS partkeydef, "
 						  "false AS ispartition, "
+						  "0 AS partitionparent, "
 						  "NULL AS partbound "
 						  "FROM pg_class c "
 						  "LEFT JOIN pg_depend d ON "
@@ -6386,6 +6409,7 @@ getTables(Archive *fout, int *numTables)
 						  "NULL AS changed_acl, "
 						  "NULL AS partkeydef, "
 						  "false AS ispartition, "
+						  "0 AS partitionparent, "
 						  "NULL AS partbound "
 						  "FROM pg_class c "
 						  "LEFT JOIN pg_depend d ON "
@@ -6455,6 +6479,7 @@ getTables(Archive *fout, int *numTables)
 	i_changed_acl = PQfnumber(res, "changed_acl");
 	i_partkeydef = PQfnumber(res, "partkeydef");
 	i_ispartition = PQfnumber(res, "ispartition");
+	i_partitionparent = PQfnumber(res, "partitionparent");
 	i_partbound = PQfnumber(res, "partbound");
 
 	if (dopt->lockWaitTimeout)
@@ -6561,6 +6586,7 @@ getTables(Archive *fout, int *numTables)
 		/* Partition key string or NULL */
 		tblinfo[i].partkeydef = pg_strdup(PQgetvalue(res, i, i_partkeydef));
 		tblinfo[i].ispartition = (strcmp(PQgetvalue(res, i, i_ispartition), "t") == 0);
+		tblinfo[i].partitionparent = atooid(PQgetvalue(res, i, i_partitionparent));
 		tblinfo[i].partbound = pg_strdup(PQgetvalue(res, i, i_partbound));
 
 		/*
